/* providers.vapi generated by valac 0.56.17, do not modify. */

namespace Kangaroo {
	namespace Providers {
		namespace Contracts {
			[CCode (cheader_filename = "providers.h")]
			public interface IDataReader : GLib.Object {
				public abstract bool bulk () throws GLib.Error;
				public abstract void close () throws GLib.Error;
				public abstract uint8[] get_binary (ushort columnIndex) throws GLib.Error;
				public abstract uint8[] get_blob (ushort columnIndex) throws GLib.Error;
				public abstract bool get_boolean (ushort columnIndex) throws GLib.Error;
				public abstract uchar get_char (ushort columnIndex) throws GLib.Error;
				public abstract Kangaroo.Model.Data.DataType get_data_type (ushort columnIndex) throws GLib.Error;
				public abstract GLib.Date get_date (ushort columnIndex) throws GLib.Error;
				public abstract GLib.DateTime get_datetime (ushort columnIndex) throws GLib.Error;
				public abstract string get_dbms_type (ushort columnIndex) throws GLib.Error;
				public abstract double get_decimal (ushort columnIndex) throws GLib.Error;
				public abstract double get_double (ushort columnIndex) throws GLib.Error;
				public virtual string get_enum (ushort columnIndex) throws GLib.Error;
				public virtual string get_flag (ushort columnIndex) throws GLib.Error;
				public abstract float get_float (ushort columnIndex) throws GLib.Error;
				public virtual string get_geography (ushort columnIndex) throws GLib.Error;
				public virtual string get_geometry (ushort columnIndex) throws GLib.Error;
				public abstract string get_guid (ushort columnIndex) throws GLib.Error;
				public abstract int16 get_int16 (ushort columnIndex) throws GLib.Error;
				public abstract int32 get_int32 (ushort columnIndex) throws GLib.Error;
				public abstract int64 get_int64 (ushort columnIndex) throws GLib.Error;
				public abstract int8 get_int8 (ushort columnIndex) throws GLib.Error;
				public virtual string get_json (ushort columnIndex) throws GLib.Error;
				public abstract double get_money (ushort columnIndex) throws GLib.Error;
				public abstract string get_name (ushort columnIndex) throws GLib.Error;
				public virtual uint8[] get_object (ushort columnIndex) throws GLib.Error;
				public virtual string get_set (ushort columnIndex) throws GLib.Error;
				public abstract size_t get_size (ushort columnIndex) throws GLib.Error;
				public abstract string get_string (ushort columnIndex) throws GLib.Error;
				public abstract string get_string16 (ushort columnIndex) throws GLib.Error;
				public abstract GLib.DateTime get_time (ushort columnIndex) throws GLib.Error;
				public abstract GLib.TimeSpan get_timespan (ushort columnIndex) throws GLib.Error;
				public virtual GLib.DateTime get_timestamp (ushort columnIndex) throws GLib.Error;
				public abstract uint16 get_uint16 (ushort columnIndex) throws GLib.Error;
				public abstract uint32 get_uint32 (ushort columnIndex) throws GLib.Error;
				public abstract uint64 get_uint64 (ushort columnIndex) throws GLib.Error;
				public abstract uint8 get_uint8 (ushort columnIndex) throws GLib.Error;
				public virtual Kangaroo.Model.Data.ValueObject get_value (ushort columnIndex) throws GLib.Error;
				public virtual Kangaroo.Model.Data.ValueObject[] get_values () throws GLib.Error;
				public virtual Kangaroo.Model.Data.ValueObject get_variant (ushort columnIndex) throws GLib.Error;
				public virtual string get_xml (ushort columnIndex) throws GLib.Error;
				public abstract bool is_null (ushort columnIndex) throws GLib.Error;
				public abstract bool read () throws GLib.Error;
				public abstract int field_count { get; }
				public abstract bool is_closed { get; }
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IProvider : GLib.Object {
				public abstract void close () throws GLib.Error;
				public abstract void commit () throws GLib.Error;
				public abstract ssize_t execute_affect (string statement, bool in_thread = false) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel execute_model (string statement, bool in_thread = false) throws GLib.Error;
				public abstract Kangaroo.Providers.Contracts.IDataReader execute_reader (string statement) throws GLib.Error;
				public abstract Kangaroo.Model.Data.ValueObject execute_scalar (string statement, bool in_thread = false) throws GLib.Error;
				public abstract GLib.Object[] execute_statements (string statements, bool in_thread = false) throws GLib.Error;
				public abstract void open (Kangaroo.Model.Setting.Server server, string connection_string = "") throws GLib.Error;
				public abstract void rollback () throws GLib.Error;
				public abstract bool transaction () throws GLib.Error;
				public abstract bool is_opened { get; }
			}
		}
		namespace Exceptions {
			[CCode (cheader_filename = "providers.h")]
			public errordomain DatabaseError {
				DATABASE_NOT_FOUND,
				DATABASE_NOT_CONNECTED,
				DATABASE_NOT_INITIALIZED,
				DATABASE_NOT_SUPPORTED,
				DATABASE_NOT_SUPPORTED_BY_PROVIDER,
				DATABASE_NOT_SUPPORTED_BY_DRIVER,
				DATABASE_NOT_SUPPORTED_BY_SERVER
			}
		}
		namespace Supports {
			[CCode (cheader_filename = "providers.h")]
			public class MariaDBProvider : GLib.Object, Kangaroo.Providers.Supports.IMariaDBError, Kangaroo.Providers.Contracts.IProvider {
				public MariaDBProvider ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class MariaDBReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader, Kangaroo.Providers.Supports.IMariaDBType, Kangaroo.Providers.Supports.IMariaDBError {
				public MariaDBReader (MariaDB.Result result);
				public uint32 get_decimals_size (ushort columnIndex) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public class MySQLProvider : GLib.Object, Kangaroo.Providers.Supports.IMySQLError, Kangaroo.Providers.Contracts.IProvider {
				public MySQLProvider ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class MySQLReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader, Kangaroo.Providers.Supports.IMySQLType, Kangaroo.Providers.Supports.IMySQLError {
				public MySQLReader (MySQL.Result result);
				public uint32 get_decimals_size (ushort columnIndex) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public class OdbcProvider : GLib.Object, Kangaroo.Providers.Supports.IOdbcError, Kangaroo.Providers.Contracts.IProvider, Kangaroo.Providers.Supports.IOdbc {
				public OdbcProvider ();
				public static string[] load_datasource ();
				public static string[] load_drivers ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class OdbcReader : GLib.Object, Kangaroo.Providers.Supports.IOdbcError, Kangaroo.Providers.Supports.IOdbcType, Kangaroo.Providers.Contracts.IDataReader {
				public OdbcReader (Odbc.Statement statement, bool in_thread = false);
			}
			[CCode (cheader_filename = "providers.h")]
			public class PostgreSQLProvider : GLib.Object, Kangaroo.Providers.Contracts.IProvider, Kangaroo.Providers.Supports.IPostgreSQLError {
				public PostgreSQLProvider ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class PostgreSQLReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader, Kangaroo.Providers.Supports.IPostgreSQLType {
				public PostgreSQLReader (Postgres.Result result);
			}
			[CCode (cheader_filename = "providers.h")]
			public class RedisProvider : GLib.Object, Kangaroo.Providers.Supports.IRedisError, Kangaroo.Providers.Contracts.IProvider {
				public RedisProvider ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class RedisReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader {
				public RedisReader ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class SQLServerProvider : GLib.Object, Kangaroo.Providers.Contracts.IProvider, Kangaroo.Providers.Supports.ISQLServerError {
				public SQLServerProvider ();
			}
			[CCode (cheader_filename = "providers.h")]
			public class SQLServerReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader, Kangaroo.Providers.Supports.ISQLServerType, Kangaroo.Providers.Supports.ISQLServerError {
				public SQLServerReader (Tds.Connection connection);
			}
			[CCode (cheader_filename = "providers.h")]
			public class SQLiteProvider : GLib.Object, Kangaroo.Providers.Supports.ISQLiteError, Kangaroo.Providers.Contracts.IProvider {
				public SQLiteProvider ();
				public Sqlite.Database? engine { get; }
			}
			[CCode (cheader_filename = "providers.h")]
			public class SQLiteReader : GLib.Object, Kangaroo.Providers.Contracts.IDataReader, Kangaroo.Providers.Supports.ISQLiteType, Kangaroo.Providers.Supports.ISQLiteError {
				public SQLiteReader (Sqlite.Database connection, Sqlite.Statement stmt);
			}
			[CCode (cheader_filename = "providers.h")]
			public class TdsMessage {
				public TdsMessage ();
				public int error { get; set; }
				public string message { get; set; }
				public int severity { get; set; }
				public string source { get; set; }
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IMariaDBError : GLib.Object {
				public void dump (MariaDB.Connection connection);
				public void raise_error (MariaDB.Connection connection, int status) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IMariaDBType : GLib.Object {
				public Kangaroo.Model.Data.DataType map_data_type (uint type_native, uint field_flags);
				public string map_dbms_type (uint type_native, uint field_flags);
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IMySQLError : GLib.Object {
				public void dump (MySQL.Connection connection);
				public void raise_error (MySQL.Connection connection, int status) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IMySQLType : GLib.Object {
				public Kangaroo.Model.Data.DataType map_data_type (uint type_native, uint field_flags);
				public string map_dbms_type (uint type_native, uint field_flags);
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IOdbc : GLib.Object, Kangaroo.Providers.Contracts.IProvider {
				public abstract Kangaroo.Model.Data.TableModel columns (string catalog, string schema, string table, string column) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel databases () throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel foreign_keys (string pkCatalog, string pkSchema, string pkTable, string fkCatalog, string fkSchema, string fkTable) throws GLib.Error;
				public abstract bool function_exists (Odbc.Function function_id) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel primary_keys (string catalog, string schema, string table) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel procedures (string catalog, string schema, string procedure) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel schemas (string catalog) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel statistics (string catalog, string schema, string table) throws GLib.Error;
				public abstract Kangaroo.Model.Data.TableModel tables (string catalog, string schema, string table, string table_type_list) throws GLib.Error;
				public abstract bool autocommit { get; set; }
				public abstract bool caseless { get; set; }
				public abstract int concurrency { get; set; }
				public abstract int maxrows { get; set; }
				public abstract int timeout { get; set; }
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IOdbcError : GLib.Object {
				public void raise_error (Odbc.HandleType type, Odbc.Handle handle, Odbc.Return retval) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IOdbcType : GLib.Object {
				public Odbc.CDataType map_c_type (short sql_type, bool type_unsigned);
				public Kangaroo.Model.Data.DataType map_data_type (short type_odbc, bool type_unsigned, string type_native);
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IPostgreSQLError : GLib.Object {
				public void raise_error_connection (Postgres.Connection connection) throws GLib.Error;
				public void raise_error_result (Postgres.Result? result) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IPostgreSQLType : GLib.Object {
				public Kangaroo.Model.Data.DataType map_data_type (Kangaroo.Providers.Supports.PostgreSQLType type_native);
				public string map_dbms_type (Kangaroo.Providers.Supports.PostgreSQLType type_native);
			}
			[CCode (cheader_filename = "providers.h")]
			public interface IRedisError : GLib.Object {
				public void raise_error_reply (Redis.Context context, Redis.Reply reply) throws GLib.Error;
				public void raise_error_response (Redis.Context context, Redis.RedisResponse response) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface ISQLServerError : GLib.Object {
				public void raise_error (Tds.ResultCode retcode) throws GLib.Error;
				public abstract Kangaroo.Providers.Supports.TdsUserData* userdata { get; }
			}
			[CCode (cheader_filename = "providers.h")]
			public interface ISQLServerType : GLib.Object {
				public int map_bind_type (int datatype);
				public Kangaroo.Model.Data.DataType map_data_type (Tds.FieldType type_native, int colsize);
				public string map_dbms_type (Tds.FieldType type_native, int colsize);
			}
			[CCode (cheader_filename = "providers.h")]
			public interface ISQLiteError : GLib.Object {
				public void raise_error (Sqlite.Database database, int status) throws GLib.Error;
			}
			[CCode (cheader_filename = "providers.h")]
			public interface ISQLiteType : GLib.Object {
				public Kangaroo.Model.Data.DataType map_data_type (int type_native);
				public string map_dbms_type (int type_native);
			}
			[CCode (cheader_filename = "providers.h")]
			public struct TdsUserData {
				public uint8 closed;
				public uint8 timeout;
				public uint8 cancel;
				public uint8 dbexec_sent;
				public uint8 dbcancel_sent;
				public uint8 nonblocking;
				public Gee.ArrayQueue<Kangaroo.Providers.Supports.TdsMessage> messages;
			}
			[CCode (cheader_filename = "providers.h")]
			public enum PostgreSQLType {
				UNSPECIFIED,
				BIT,
				BIT_ARRAY,
				BOOLEAN,
				BOOLEAN_ARRAY,
				BOX,
				BOX_ARRAY,
				BPCHAR,
				BPCHAR_ARRAY,
				BYTEA,
				BYTEA_ARRAY,
				CHAR,
				CHAR_ARRAY,
				CIDR,
				CIRCLE,
				DATE,
				DATE_ARRAY,
				FLOAT4,
				FLOAT4_ARRAY,
				FLOAT8,
				FLOAT8_ARRAY,
				INET,
				INT2,
				INT2_ARRAY,
				INT4,
				INT4_ARRAY,
				INT8,
				INT8_ARRAY,
				INTERVAL,
				INTERVAL_ARRAY,
				JSON,
				JSON_ARRAY,
				JSONB,
				JSONB_ARRAY,
				LINE,
				LSEG,
				MACADDR,
				MACADDR8,
				MONEY,
				MONEY_ARRAY,
				NAME,
				NAME_ARRAY,
				NUMERIC,
				NUMERIC_ARRAY,
				OID,
				OID_ARRAY,
				PATH,
				POINT,
				POINT_ARRAY,
				POLYGON,
				REF_CURSOR,
				REF_CURSOR_ARRAY,
				TEXT,
				TEXT_ARRAY,
				TIME,
				TIME_ARRAY,
				TIMESTAMP,
				TIMESTAMP_ARRAY,
				TIMESTAMPTZ,
				TIMESTAMPTZ_ARRAY,
				TIMETZ,
				TIMETZ_ARRAY,
				TSQUERY,
				TSVECTOR,
				UUID,
				UUID_ARRAY,
				VARBIT,
				VARBIT_ARRAY,
				VARCHAR,
				VARCHAR_ARRAY,
				VOID,
				XML,
				XML_ARRAY
			}
		}
	}
}
